#include "sema.h"

int sema_lock(sema_t *s)
{
	while (s->locked)
		thread_cooperate();
	
	s->locked = 1;
	return 0;
}

int sema_unlock(sema_t *s)
{
	s->locked = 0;
	return 0;
}

int rwsema_readlock(rwsema_t *s)
{
	while (s->writer)
		thread_cooperate();
	
	++s->readers;
	return 0;
}

int rwsema_writelock(rwsema_t *s)
{
	while (s->writer || s->readers)
		thread_cooperate();
	
	s->writer = 1;
	return 0;
}

int rwsema_unlock(rwsema_t *s)
{
	if (s->writer)
		s->writer = 0;
	else
		--s->readers;
	
	return 0;
}
