.module list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; input:
; 	HL	address of list
; 	DE	address of node
; output:
; 	Carry set on error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
list_append_node:
	ld	a,l
	or	h
	scf
	ret	z			; list == NULL, return -1
		push	hl
	call	LD_HL_MHL
	ld	a,l
	or	h
	jr	nz,_append_node1	; list->head == NULL
	ld	h,d
	ld	l,e
	ld	(hl),e
	inc	hl
	ld	(hl),d			; node->next = node
		pop	hl
		push	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d			; list->head = node
	jr	_append_node2
_append_node1				; hl = list->head, de = node
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d			; node->next = list->head
	dec	hl
	ex	de,hl
		pop	hl		; hl = list
		push	hl
	inc	hl
	inc	hl
	call	LD_HL_MHL		; hl = &list->tail->next
	ld	(hl),e
	inc	hl
	ld	(hl),d			; list->tail->next = node
_append_node2
		pop	hl
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d			; list->tail = node
	or	a
	ret				; return 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; input:
; 	HL	address of list
; output:
; 	Carry set on error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
list_remove_head:
	ld	a,l
	or	h
	scf
	ret	z			; list == NULL
	ld	a,(hl)
	inc	hl
	or	(hl)
	dec	hl
	scf
	ret	z			; list->head == NULL
		push	hl
	ld	b,(hl)
	inc	hl
	ld	a,(hl)
	inc	hl
	cp	(hl)
	jr	nz,_remove_head1
	inc	hl
	ld	a,(hl)
	cp	b
	jr	nz,_remove_head1	; list->head == list->tail
		pop	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a			; list->head = NULL
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a			; list->tail = NULL
	jr	_remove_head2
_remove_head1
		pop	hl
		push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
		pop	hl
		push	de
	ld	(hl),e
	inc	hl
	ld	(hl),d			; list->head = list->head->next
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
		pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d			; list->tail->next = list->head->next
_remove_head2
	or	a
	ret				; return 0
